Subject: Re: bug#31184: tail -f on Network FS not refreshing as soon as the file is changed.

From: Pádraig Brady <[email-masked]>
Date: Wed, 2 May 2018 00:45:49 -0700

On 19/04/18 07:43, Jewsco Pius Jacquez wrote:
> Pádraig, thanks for your response.
> 
> In my reproducer environment, it doesn't totally update. RHEL7 Samba server, RHEL6 Samba client.
> 
> Unless I provided the extra interval parameter. 

You said you used: tail --follow=name --max-unchanged-stats=1 --sleep-interval=1

The --sleep-interval=1 having a difference is confusing
as that already defaults to one second.
Also --max-unchanged-stats=1 should only make things more responsive.
I would have expected only --follow=name to have a significant
difference to the data that is eventually output.

Anyway there may be an issue with st_size updating on your system.
I.E. if stat() didn't update st_size on this remote file
then a new change that protects against a related issue
on glusterfs may be impacting here. One could check that
by reverting the patch and rebuilding in your previous build dir like:

  cd coreutils-8.29 &&
  wget 'https://github.com/coreutils/coreutils/commit/7fc7206.patch' -O- |
  patch -R -p1 &&
  make

One might also check this externally to tail(1) by repeatedly running
the following and seeing does the number correlate with remote changes:

  stat -c '%s' /media/samba/test.file

cheers,
Pádraig